<template>
  <div class="app-container">
    <el-select v-model="dataForm.role">
      <el-option v-for="(i,index) in roles" :key="index" :label="i.role" :value="i.role" />
    </el-select>
    <el-button round type="primary" @click="queryAction">查詢</el-button>
    <el-button round type="primary" @click="addAction">新增/更新/刪除</el-button>
    <el-button round type="primary" @click="resetAction">重置</el-button>
    <el-divider />
    <el-transfer
      v-model="dataForm.api"
      :props="{
        key: 'key',
        label: 'value'
      }"
      :data="paths"
      :titles="['未勾選API', '已勾選API']"
      class="transfer-class"
    />
  </div>
</template>
<script>
import { getAllRoles, test, addApiPermission, getCheckApi } from './action'
export default {
  data() {
    return {
      roles: [],
      paths: [],
      dataForm: {
        api: [],
        role: ''
      },
      value: []
    }
  },
  mounted() {
    this.getPaths()
    this.getAllRolesAction()
  },
  methods: {
    queryAction: function() {
      if (this.dataForm.role.length < 1) {
        alert('請選擇角色!')
        return false
      }

      getCheckApi({ role: this.dataForm.role }).then(res => {
        if (res.status === 'OK') {
          this.dataForm.api = res.data
          alert('查詢成功!')
        }
      })
    },
    addAction: function() {
      addApiPermission(this.dataForm).then(res => {
        if (res.status === 'OK') {
          alert('成功')
        }
      })
    },
    resetAction: function() {
      this.dataForm.api = []
      this.dataForm.role = ''
    },
    getAllRolesAction: function() {
      getAllRoles().then(res => {
        this.roles = res.data
      })
    },
    getPaths: function() {
      test().then(res => {
        if (res.status === 'OK') {
          this.paths = res.data
        }
      })
    }
  }
}
</script>

<style>
.transfer-class .el-transfer-panel {
  border: 1px solid #ebeef5;
  border-radius: 4px;
  overflow: hidden;
  background: #fff;
  display: inline-block;
  vertical-align: middle;
  width: 450px;
  -webkit-box-sizing: border-box;
  box-sizing: border-box;
  position: relative;
}
</style>
